#include <stdio.h>
#include <math.h>
#define m 50000
FILE *fp1,*fp2,*fp3;
double ra[m],de[m];
float x[m],y[m],mag[m],err[m]; 
double a8[8],b8[8];
char head[72][80];
int n1,n2;
float cali;
int  aper[10];
float u[10],v[10];
double pi,cx,cy;
main(int ac, char **av)
{
  int i,j,k,n,ip;
  double cosx,xx,yy,z,zz,r,rr;
  char f1[30],f2[30],f3[30],f4[30],a[182],c;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<3){
    printf("\n\t ***** bok_u change to mag2,mag3 style ****\n");
    printf("\n\t after standard 4key, get a boku.cat,");
    printf("\n\t 1. produce a boku.mag2 append X,y");
    printf("\n\t 2. produce a boku.coo from boku.mag2");
    printf("\n\t 3. produce a boku.ap (u_phot4k) with a new pip2.par");
    printf("\n\t    cp /vgea2/rhbin/boku2mag.par bok.par");
    printf("\n\t    aperture 11,14,19,...60; 17/0.454*x"); 
    printf("\n\t 4. produce a boku.mag3, only chang format of boku.ap\n");
    printf("\n\tUsage: boku2mag ta02u.cat Ta02i_15.mag\n\n");
    exit(0);
  }
  strcpy(f1,av[1]);           // read: our *.cat  ta02u.cat
  strcpy(f2,av[2]);           // read: 2k.mag2    Ta02i_15.mag2
  strcpy(f3,f1);  
  for(j=0;j<strlen(f3);j++)if(f3[j]=='.')break;
// read a8
  sprintf(&f3[j],".fit"); strcpy(f4,f3);
  fp3=fopen(f3,"rb"); if(!fp3){ printf("\t%s not found!\n",f3); exit(0); }
  fread(head,72,80,fp3); fclose(fp3);
  k=indexpos(head,"NAXIS1  ",72);
  sscanf(&head[k++][23],"%d",&n1);
  sscanf(&head[k++][23],"%d",&n2);
  k=indexpos(head,"CALIBRAT",72);
  cali=4.0; if(k!=72)sscanf(&head[k][23],"%f",&cali);
  k=indexpos(head,"A81     ",72);
  if(k==72){ printf("\nfits_file not coordinated !\n"); exit(0); }
  for(i=0;i<8;i++)sscanf(&head[k+i][10],"%le",&a8[i]);
  xytoad(a8,b8);
// read a8 end  
  f3[0]&=0x5f;
  sprintf(&f3[j],".mag2");    // write: our *.mag2 Ta02u.mag2
//  printf("%s\n",f3);
  fp1=fopen(f1,"r"); if(!fp1){ printf("\t%s not found!\n",f1); exit(0); }
  fp2=fopen(f2,"r"); if(!fp2){ printf("\t%s not found!\n",f2); exit(0); }
  fp3=fopen(f3,"w");
  i=0;
l10:
  fgets(a,182,fp1); if(feof(fp1))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(&a[32],"%f %f",&x[i],&y[i]);
  sscanf(&a[72],"%f %f",&mag[i],&err[i]); a[32]=0;
  itohd(&a[6],&ra[i],&de[i]);  i++;
  goto l10;
l20:
  n=i; fclose(fp1);        // *.cat readin
// write boku.coo
  sprintf(&f1[j],".coo");    // write: our *.coo
  fp1=fopen(f1,"w");
  fprintf(fp1," NL   NX   NY  LOWBAD HIGHBAD  THRESH     AP1  PH/ADU  RNOISE    FRAD\n");
  fprintf(fp1,"  1%5d%5d    24.9 60000.0   22.76   10.00    1.90    9.00    10.00\n\n",n1,n2);
// 
  fgets(a,182,fp2);
  sprintf(&a[30],"8k  u");
  fprintf(fp3,"%s\n",a);
  itohd(&a[7],&xx,&yy);
  cosx=cos(yy*cy);
  k=ip=0;
l110: 
  fgets(a,182,fp2); if(feof(fp2))goto l120;
  itohd(&a[7],&xx,&yy);
  r=1.5/3600.; j=-1;                // 1"
  for(i=0;i<n;i++){
    zz=de[i]-yy; if(zz>r)break;
    z=(xx-ra[i])*cosx; 
    zz=sqrt(zz*zz+z*z);
    if(zz<r){ j=i; r=zz; }
  }
// sscanf(&a[79],"%lf",&rr);
  z=zz=0.;
  if(j>0){ 
    k++; z=mag[j]; xx=x[j]; yy=y[j]; zz=err[j];
// r*=3600.; if(r>1.)printf("%3.1lf %6.2lf\n",r,z-rr);
  } else rad_xy(a8[6],a8[7],xx,yy,&xx,&yy,1,0);
  fprintf(fp1,"%5d %9.3lf %9.3lf\n",++ip,xx,yy);
  sprintf(&a[30],"%6.2f %7.2lf %7.2lf",z,xx,yy);
  fprintf(fp3,"%s\n",a);
  fgets(a,182,fp2);
  sprintf(&a[30],"%6.2f",zz);
  fprintf(fp3,"%s\n",a);
  goto l110;
l120: n=i;
  fclose(fp1); fclose(fp2); fclose(fp3);
  printf("all star: %d  matched star: %d\n",ip,k);
//  
  sprintf(a,"cp /vega2/rhbin/bok2k.par bok.par"); system(a);
// read aper[10]
  fp1=fopen("bok.par","r");
  fgets(a,182,fp1); 
  while(a[0]=='*')fgets(a,182,fp1);
  while(a[0]!='*')fgets(a,182,fp1);
  for(i=0;i<10;i++){ fgets(a,182,fp1); sscanf(&a[31],"%d",&aper[i]); }
  fclose(fp1);
  for(i=0;i<10;i++)printf("%d ",aper[i]); printf("\n");

  sprintf(a,"u_phot4k %s",f4);                    system(a);
// read Ta02u.mag2 ta02u.ap ---> Ta02u.mag3
//        f3         f2             f1          f4=ta02u.fit
  strcpy(f1,f3);  k=strlen(f1)-1;  f1[k]='3';
  strcpy(f2,f4);  k=strlen(f2)-3;  f2[k]='a'; f2[k+1]='p'; f2[k+2]=0;
//printf("%s %s %s\n",f1,f2,f3);
  fp1=fopen(f1,"w"); fp2=fopen(f2,"r"); fp3=fopen(f3,"r");
  fgets(a,182,fp3); fprintf(fp1,"%s",a);
  for(i=0;i<4;i++)fgets(a,182,fp2);
  z=0.0; ip=1;
l210:
  fgets(a,182,fp3); if(feof(fp3))goto l220;
  sscanf(&a[1],"%d",&j);fprintf(fp1,"%s",a);
  fgets(a,182,fp3); fprintf(fp1,"%s",a);
  if(ip){
    fgets(a,182,fp2); sscanf(a,"%d",&k);
    for(i=0;i<10;i++)sscanf(&a[i*9+26],"%f",&u[i]);  
    for(i=0;i<10;i++)if(u[i]>5. && u[i]<30.)u[i]+=cali;
    fgets(a,182,fp2);
    for(i=0;i<10;i++)sscanf(&a[i*9+26],"%f",&v[i]);  
    fgets(a,182,fp2);
  }
  if(j==k){
    for(i=0;i<10;i++){
      fprintf(fp1,"%28d %7.2f\n",aper[i],u[i]);
      fprintf(fp1,"%36.2f\n",v[i]);
    } ip=1;
  } else {
    for(i=0;i<10;i++){
      fprintf(fp1,"%28d %7.2f\n",aper[i],z);
      fprintf(fp1,"%36.2f\n",z);
    } ip=0;
  }
  goto l210;
l220:
  fclose(fp1); fclose(fp2); fclose(fp3);
}

itohd(a,rc,dc)
char *a; double *rc,*dc;
{
  int i,j,k;
  int i1,i2,j1,j2;
  double x3,y3;
  char b[70];
  strcpy(b,a);
  for(i=0;i<24;i++)if(b[i]==':')b[i]=32;
  k=1; if(b[11]=='-'){ b[11]=32; k=-1; }
  sscanf(b,"%d %d %lf %d %d %lf",&i1,&i2,&x3,&j1,&j2,&y3);
//  printf("%2d %2d %5.2lf %2d %2d %4.1lf\n",i1,i2,x3,j1,j2,y3);
  x3=i1+i2/60.+x3/3600.;
  y3=j1+j2/60.+y3/3600.; if(k==-1)y3=-y3;
  *rc=x3;
  *dc=y3;
}
              
xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

